id: rgp_sink_field_instance
label: 'Import fields instance'
migration_group: sink

source:
  plugin: url
  data_fetcher_plugin: http
  data_parser_plugin: json
  urls: 'http://akeneoce.hicmedia.com/customapi/api/en/V1/GetRMSinksAttributes'
  item_selector: data
  track_changes: true
  authentication:
    plugin: oauth2
    grant_type: client_credentials
    base_uri: http://akeneoce.hicmedia.com
    token_url: /customapi/api/en/v2/GetToken
    client_id: agawebsite
    client_secret: 'Sd[eW_d;YNN7'
  fields:
    - name: code
      label: 'Machine name'
      selector: code
    - name: label
      label: 'Name'
      selector: label
    - name: type
      label: 'Type'
      selector: type
    - name: group_id
      label: 'Group'
      selector: group_id
    - name: description
      label: 'Group'
      selector: description
  ids:
    code:
      type: string
  constants:
    entity_type: commerce_product_variation
    bundle: sink
    translatable: true

process:
  entity_type: constants/entity_type

  machine_code:
    -
      plugin: machine_name
      source: code
    -
      plugin: substr
      start: 0
      length: 32

  field_name:
    -
      plugin: skip_on_value
      source: code
      method: row
      value:
        - sku
        - title
        - Price
    -
      plugin: default_value
      source: '@machine_code'

  bundle: constants/bundle
  label: label
  translatable: constants/translatable

  description: description

destination:
  destination_module: rg_import
  plugin: entity:field_config
  overwrite_properties:
    - label
    - description

migration_dependencies:
  required:
    - rgp_sink_field_storage

dependencies:
  enforced:
    module:
      - rg_import
